#######################################################################
# Copyright (c) 2018 Josef Spidlen, Ph.D., FlowJo, LLC
#
# License
# The software is distributed under the terms of the 
# Artistic License 2.0
# http://www.r-project.org/Licenses/Artistic-2.0
# 
# Disclaimer
# This software and documentation come with no warranties of any kind.
# This software is provided "as is" and any express or implied 
# warranties, including, but not limited to, the implied warranties of
# merchantability and fitness for a particular purpose are disclaimed.
# In no event shall the  copyright holder be liable for any direct, 
# indirect, incidental, special, exemplary, or consequential damages
# (including but not limited to, procurement of substitute goods or 
# services; loss of use, data or profits; or business interruption)
# however caused and on any theory of liability, whether in contract,
# strict liability, or tort arising in any way out of the use of this 
# software.
######################################################################

debug_input_output <- TRUE

## For debugging purposes
sessionInfo()

## For debugging to see what FlowJo is passing to the script.
##
## cat("FJ-PAR-PREFIX                = FJ_PAR_PREFIX \n")
## cat("FJ-PAR-DER-PAR-NAME          = FJ_PAR_DER_PAR_NAME \n")
## cat("FJ-FITSNE-BINARY-PATH        = FJ_FITSNE_BINARY_PATH \n")
## cat("FJ-DATA-FILE-PATH            = FJ_DATA_FILE_PATH \n")
## cat("FJ-CSV-OUPUT-FILE            = FJ_CSV_OUPUT_FILE \n")
## cat("FJ-PARAMS-LIST               = FJ_PARAMS_LIST \n")
## cat("FJ-PAR-PREFIX                = FJ_PAR_PREFIX \n")
## cat("FJ-PAR-ADD-CELLIDS-TO-RESULT = FJ_PAR_ADD_CELLIDS_TO_RESULT \n")
## cat("FJ-PAR-DIMS                  = FJ_PAR_DIMS \n")
## cat("FJ-PAR-ALG                   = FJ_PAR_ALG \n")
## cat("FJ-PAR-KNN                   = FJ_PAR_KNN \n")
## cat("FJ-PAR-PERPLEXITY            = FJ_PAR_PERPLEXITY \n")
## cat("FJ-PAR-MAX-ITER              = FJ_PAR_MAX_ITER \n")
## cat("FJ-PAR-STOP-LYING-ITER       = FJ_PAR_STOP_LYING_ITER \n")
## cat("FJ-PAR-EXAG-FACTOR           = FJ_PAR_EXAG_FACTOR \n")
## cat("FJ-PAR-THETA                 = FJ_PAR_THETA \n")
## cat("FJ-PAR-LATE-EXAG-COEFF       = FJ_PAR_LATE_EXAG_COEFF \n")
## cat("FJ-PAR-START-LATE-EXAG       = FJ_PAR_START_LATE_EXAG \n")
## cat("FJ-PAR-NUM-TREES             = FJ_PAR_NUM_TREES \n")
## cat("FJ-PAR-NUM-TERMS             = FJ_PAR_NUM_TERMS \n")
## cat("FJ-PAR-SEARCH-K              = FJ_PAR_SEARCH_K \n")
## cat("FJ-PAR-OTHER-K               = FJ_PAR_OTHER_K \n")
## cat("FJ-PAR-SIGMA                 = FJ_PAR_SIGMA \n")
## cat("FJ-PAR-MIN-NUM-INTERVALS     = FJ_PAR_MIN_NUM_INTERVALS \n")
## cat("FJ-PAR-INTERVALS-PER-INTEGER = FJ_PAR_INTERVALS_PER_INTEGER \n")
## cat("FJ-PAR-SEED                  = FJ_PAR_SEED \n")
## cat("FJ-PAR-NO-MOM-DURING-EXAG    = FJ_PAR_NO_MOM_DURING_EXAG \n")
## cat("FJ-PAR-LEARNING-RATE         = FJ_PAR_LEARNING_RATE \n")


EventNumberDP <- "EventNumberDP"
CellIdDP <- "CellId"
addCellIdsToResult <- FJ_PAR_ADD_CELLIDS_TO_RESULT

tSNE_bin_path <- "FJ_FITSNE_BINARY_PATH"
parNames <- c(FJ_PARAMS_LIST)

fjDataFilePath <- "FJ_DATA_FILE_PATH"
fjCsvOutputFile <- "FJ_CSV_OUPUT_FILE"
fjPrefix <- "FJ_PAR_PREFIX"
fjDerParName <- "FJ_PAR_DER_PAR_NAME"
fjDims <- FJ_PAR_DIMS
fjAlg <- "FJ_PAR_ALG"
fjKnn <- "FJ_PAR_KNN"
fjMaxIter <- FJ_PAR_MAX_ITER
fjStopLyingIter <- FJ_PAR_STOP_LYING_ITER
fjPerplexity <- FJ_PAR_PERPLEXITY
fjExaggerationFactor <- FJ_PAR_EXAG_FACTOR
fjTheta <- FJ_PAR_THETA
fjLateEgCoeff <- FJ_PAR_LATE_EXAG_COEFF
fjStartLateExag <- FJ_PAR_START_LATE_EXAG
fjNumTrees <- FJ_PAR_NUM_TREES
fjNumTerms <- FJ_PAR_NUM_TERMS
fjSearchK <- FJ_PAR_SEARCH_K
fjK <- FJ_PAR_OTHER_K
fjSigma <- FJ_PAR_SIGMA
fjMinNumIntervals <- FJ_PAR_MIN_NUM_INTERVALS
fjIntervalsPerInteger <- FJ_PAR_INTERVALS_PER_INTEGER
fjSeed <- FJ_PAR_SEED
fjNoMomentumDuringExag <- FJ_PAR_NO_MOM_DURING_EXAG
fjParLearningRate <- FJ_PAR_LEARNING_RATE

if (fjAlg == "fft") {
	fj_fft_not_bh <- TRUE
} else {
	fj_fft_not_bh <- FALSE
}

if (fjKnn == "ann") {
	fj_ann_not_vptree <- TRUE
} else {
	fj_ann_not_vptree <- FALSE
}

if (fjDerParName == "") { 
	derParName <- paste0("FItSNE_", fjPrefix, fjAlg, "_", fjKnn, "_D", fjDims, "_It", fjMaxIter, "_", fjStopLyingIter, "_P", 
		fjPerplexity, "_E", fjExaggerationFactor, "_El", fjStartLateExag, "_", fjLateEgCoeff, 
		"_Th", fjTheta, "_Tr", fjNumTrees, "_Tm", fjNumTerms, "_SK", fjSearchK, "_K", fjK,
		"_Sg", fjSigma, "_MI", fjMinNumIntervals, "_IPI", fjIntervalsPerInteger, "_")
	if (fjNoMomentumDuringExag) {
		derParName <- paste0(derParName, "NMDE_")
	}
} else {
	derParName <- fjDerParName
}

## 
stopAndReturnError <- function(message, ...) {
	cat(message, file=paste0(fjCsvOutputFile, "_err.txt"))
	stop(message, ...)
}

## Slightly adapted from https://github.com/KlugerLab/FIt-SNE
fftRtsne <- function(X,
		dims = 2,                         ## Has UI input from plugin
		perplexity = 30,                  ## Has UI input from plugin
		theta = 0.5,                      ## Has UI input from plugin
		check_duplicates = TRUE,          ## Not used?
		max_iter = 1000,                  ## Has UI input from plugin
		fft_not_bh = TRUE,                ## Has UI input from plugin
		ann_not_vptree = TRUE,            ## Has UI input from plugin
		stop_lying_iter = 250,            ## Has UI input from plugin
		exaggeration_factor = 12.0,       ## Has UI input from plugin
		no_momentum_during_exag = FALSE,  ## Has UI input from plugin
		start_late_exag_iter = -1.0,      ## Has UI input from plugin
		late_exag_coeff = 1.0,            ## Has UI input from plugin
		
		## TODO, these are new and will need input from plugin UI
		mom_switch_iter=250, momentum=.5, final_momentum=.8, learning_rate=200,
		load_affinities = NULL,
		n_trees = 50,                     ## Has UI input from plugin
		search_k = -1,                    ## Has UI input from plugin
		rand_seed = -1,                   ## Has UI input from plugin
		nterms = 3,                       ## Has UI input from plugin
		intervals_per_integer = 1,        ## Has UI input from plugin
		min_num_intervals = 50,           ## Has UI input from plugin
		K = -1,                           ## Has UI input from plugin
		sigma = -30,                      ## Has UI input from plugin
		initialization = NULL,
		data_path = NULL, 
		result_path = NULL,
		fast_tsne_path = tSNE_bin_path, 
		nthreads = 0, 
		get_costs = FALSE,
		...) 
{
	stop_early_exag_iter <- stop_lying_iter
	load_affinities <- NULL
	if (is.null(load_affinities)) {
		load_affinities = 0;
	} else {
		if (load_affinities == 'load') {
			load_affinities = 1;
		} else if (load_affinities == 'save') {
			load_affinities = 2;
		} else {
			load_affinities = 0;
		}
	}
	
	
	X <- matrix(as.numeric(X), nrow = nrow(X))
	if (is.null(data_path)) {
		data_path <- tempfile(pattern='fftRtsne_data_', fileext='.dat')
	}
	if (is.null(result_path)) {
		result_path <- tempfile(pattern='fftRtsne_result_', fileext='.dat')
	}
	if (is.null(fast_tsne_path)) {
		fast_tsne_path <- system2('which', 'fast_tsne', stdout=TRUE)
	}
	fast_tsne_path <- normalizePath(fast_tsne_path)
	if (!file_test('-x', fast_tsne_path)) {
		stop(fast_tsne_path, " does not exist or is not executable; check your fast_tsne_path parameter")
	}
	
	is.wholenumber <- function(x, tol = .Machine$double.eps^0.5)  abs(x - round(x)) < tol
	
	if (!is.numeric(theta) || (theta<0.0) || (theta>1.0) ) { stop("Incorrect theta.")}
	if (nrow(X) - 1 < 3 * perplexity) { stop("Perplexity is too large.")}
	if (!is.matrix(X)) { stop("Input is not a matrix")}
	if (!(max_iter>0)) { stop("Incorrect number of iterations.")}
	if (!is.wholenumber(stop_lying_iter) || stop_lying_iter<0) { stop("The stop_lying_iter parameter should be a positive integer")}
	if (!is.numeric(exaggeration_factor)) { stop("The exaggeration_factor parameter should be numeric")}
	if (!is.wholenumber(dims) || dims<=0) { stop("Incorrect dimensionality.")}
	if (search_k == -1) { if (perplexity>0) {search_k = n_trees*perplexity*3} else { search_k = n_trees*K*3} }
	
	if (fft_not_bh){
		nbody_algo = 2;
	} else{
		nbody_algo = 1;
	}
	
	if (ann_not_vptree){
		knn_algo = 1;
	} else{
		knn_algo = 2;
	}
	tX = c(t(X))
	
	f <- file(data_path, "wb")
	n = nrow(X);
	D = ncol(X);
	
	#
	#writeBin( as.integer(n), f, size= 4)
	#writeBin( as.integer(D), f, size= 4)
	#writeBin( as.numeric(theta), f, size= 8)
	#writeBin( as.numeric(perplexity), f, size= 8) 
	#
	#writeBin( as.integer(mom_switch_iter),f,size=4)
	#writeBin( as.numeric(momentum),f,size=8)
	#writeBin( as.numeric(final_momentum),f,size=8)
	#writeBin( as.numeric(learning_rate),f,size=8)
	#
	#writeBin( as.integer(dims), f, size=4)
	#writeBin( as.integer(max_iter),f, size=4)
	#writeBin( as.integer(stop_lying_iter),f, size=4)
	#writeBin( as.integer(K),f, size=4)
	#writeBin( as.numeric(sigma), f, size=8)
	#writeBin( as.integer(nbody_algo), f, size=4)
	#writeBin( as.integer(knn_algo), f, size=4)
	#writeBin( as.numeric(exaggeration_factor), f, size=8)
	#writeBin( as.integer(no_momentum_during_exag), f, size=4) 
	#writeBin( as.integer(n_trees), f, size=4) 
	#writeBin( as.integer(search_k), f, size=4) 
	#writeBin( as.integer(start_late_exag_iter), f, size=4) 
	#writeBin( as.numeric(late_exag_coeff), f, size=8) 
	#writeBin( as.integer(nterms), f, size=4) 
	#writeBin( as.numeric(intervals_per_integer), f, size=8) 
	#writeBin( as.integer(min_num_intervals), f, size=4) 
	#
	#tX = c(t(X))
	#writeBin(tX, f) 
	#writeBin(as.integer(rand_seed), f,size=4) 
	#if (!is.null(initialization)) { writeBin( c(t(initialization)), f) }		
	#close(f)

	writeBin(as.integer(n), f,size= 4)
	writeBin( as.integer(D),f,size= 4)
	writeBin( as.numeric(theta), f,size= 8) #theta
	writeBin( as.numeric(perplexity), f,size= 8) #theta

	if (perplexity == 0) {
		writeBin( as.integer(length(perplexity_list)), f, size=4)
		writeBin( perplexity_list, f) 
	}

	writeBin( as.integer(dims), f,size=4) #theta
	writeBin( as.integer(max_iter),f,size=4)
	writeBin( as.integer(stop_early_exag_iter),f,size=4)
	writeBin( as.integer(mom_switch_iter),f,size=4)
	writeBin( as.numeric(momentum),f,size=8)
	writeBin( as.numeric(final_momentum),f,size=8)
	writeBin( as.numeric(learning_rate),f,size=8)
	writeBin( as.integer(K),f,size=4) #K
	writeBin( as.numeric(sigma), f,size=8) #sigma
	writeBin( as.integer(nbody_algo), f,size=4)  #not barnes hut
	writeBin( as.integer(knn_algo), f,size=4) 
	writeBin( as.numeric(exaggeration_factor), f,size=8) #compexag
	writeBin( as.integer(no_momentum_during_exag), f,size=4) 
	writeBin( as.integer(n_trees), f,size=4) 
	writeBin( as.integer(search_k), f,size=4) 
	writeBin( as.integer(start_late_exag_iter), f,size=4) 
	writeBin( as.numeric(late_exag_coeff), f,size=8) 

	writeBin( as.integer(nterms), f,size=4) 
	writeBin( as.numeric(intervals_per_integer), f,size=8) 
	writeBin( as.integer(min_num_intervals), f,size=4) 
	tX = c(t(X))
	writeBin( tX, f) 
	writeBin( as.integer(rand_seed), f,size=4) 
	writeBin( as.integer(load_affinities), f,size=4) 
	if (! is.null(initialization)){ writeBin( c(t(initialization)), f) }	
	close(f)

	
	rm(tX)
	rm(X)
	
	flag= system2(command=fast_tsne_path, args=c(data_path, result_path, nthreads));
	if (flag != 0) {
		stop('FIt-SNE call failed');
	}

	#f <- file(result_path, "rb")
	#initialError <- readBin(f, integer(), n=1, size=8);
	#n <- readBin(f, integer(), n=1, size=4);
	#d <- readBin(f, integer(), n=1,size=4);
	#Y <- readBin(f, numeric(), n=n*d);
	#Yout <- t(matrix(Y, nrow=d));
	#close(f)
	
	f <- file(result_path, "rb")
	n <- readBin(f, integer(), n=1, size=4);
	d <- readBin(f, integer(), n=1, size=4);
	Y <- readBin(f, numeric(), n=n*d);
	Y <- t(matrix(Y, nrow=d));
	if (get_costs) {
		costs <- readBin(f, numeric(), n=max_iter,size=8);
		Yout <- list( Y=Y, costs=costs);
	}else {
		Yout <- Y;
	}
	close(f)
	
	file.remove(data_path)
	file.remove(result_path)
	return(Yout)	
}

## Returns a list of 3 elements
## X = a matrix of data from a CSV file as exported by FlowJo
## cellIds = a matrix with CellIds (if available)
## eventNumbers = a matrix with EventNumberDP (if available)
##
## csvPath: path the the CSV file as exported from FlowJo (including header with both stain and parameter is recommended when exporting from FlowJo)
readFlowJoCSV <- function(csvPath) {
	data <- read.csv(csvPath, check.names=FALSE)
	cellIdsColumn <- rep(NA, nrow(data))
	cellIds <- data.frame(CellIdDP = cellIdsColumn)
	names(cellIds) <- CellIdDP
	if (CellIdDP %in% names(data)) {
		cellIds <- data[, CellIdDP]
		data <- data[, -which(names(data) %in% c(CellIdDP))]
	}
	
	EventNumberColumn <- rep(NA, nrow(data))
	eventNumbers <- data.frame(EventNumberDP = EventNumberColumn)
	names(eventNumbers) <- EventNumberDP
	if (EventNumberDP %in% names(data)) {
		eventNumbers <- data[, EventNumberDP]
		data <- data[, -which(names(data) %in% c(EventNumberDP))]
	}
	
	# Trim the leading and tailing whitespaces
	colnames(data) <- gsub("^\\s+|\\s+$", "", colnames(data))
	list(X=as.matrix(data), cellIds=as.matrix(cellIds), eventNumbers=as.matrix(eventNumbers))	
}

if (debug_input_output)
	file.copy(fjDataFilePath, paste(fjDataFilePath, "backup.csv", sep="."))

tmpRet = readFlowJoCSV(fjDataFilePath);
inputMatrix <- tmpRet$X
cellIds <- tmpRet$cellIds
eventNumbers <- tmpRet$eventNumbers
colnames(eventNumbers) <- c(EventNumberDP)
rm(tmpRet)

## DEGUB printout
summary(inputMatrix)

## DEGUB printout
parNames


if (fjParLearningRate == 0) {
	fjParLearningRate <- as.integer(as.numeric(dim(inputMatrix)[1]) / fjExaggerationFactor)
	cat(paste("Auto adapted learning rate to", fjParLearningRate, "\n"))
}
			

## Run FIt-SNE with input and arguments specified by the plugin user
outputMatrix <- fftRtsne(
	inputMatrix,
	dims = fjDims,
	perplexity = fjPerplexity,
	theta = fjTheta,
	check_duplicates = TRUE, ## This does not seem to be used
	max_iter = fjMaxIter,
	fft_not_bh = fj_fft_not_bh,
	ann_not_vptree = fj_ann_not_vptree,
	stop_lying_iter = fjStopLyingIter,
	exaggeration_factor = fjExaggerationFactor,
	no_momentum_during_exag = fjNoMomentumDuringExag,
	start_late_exag_iter = fjStartLateExag,
	
	mom_switch_iter=250, momentum=.5, final_momentum=.8, learning_rate=fjParLearningRate,
	load_affinities = NULL,
	
	late_exag_coeff = fjLateEgCoeff,
	n_trees = fjNumTrees,
	search_k = fjSearchK,
	rand_seed = fjSeed,
	nterms = fjNumTerms,
	intervals_per_integer = fjIntervalsPerInteger,
	min_num_intervals = fjMinNumIntervals,
	K = fjK,
	sigma = fjSigma, 
	initialization = NULL,
	data_path = NULL, 
	result_path = NULL,
	fast_tsne_path = tSNE_bin_path, 
	nthreads = 0,
	get_costs = FALSE
)

if ((NA %in% outputMatrix) || (NaN %in% outputMatrix)) {
  stopAndReturnError("Unfortunately, we were unable to calculate results for this input\n(NaN in the resulting matrix). You may want to change the input arguments.")
} else {
  if (addCellIdsToResult && !(NA %in% cellIds)) {
	  ## SeqGeq
	  outputMatrix <- cbind(cellIds, outputMatrix)
	  colnames(outputMatrix) <- c(CellIdDP, paste0(derParName, 1:fjDims))
	  ## Header to specify that those are metadata parameters, not genes.
	  ## That should work with CSVSample.mergeDataFile in SeqGeq, but it does not seem to work reliably, and it does not seem to 
	  ## recognize derived parameters as metadata anyway, so let's just do it without a header for now
	  ##
	  ## cat("[Metadata]\n$Organization\tParamsInCols\n$ParamTypes\tIm\n$EventTypes\tIv\n\n[Data]\n", file = fjCsvOutputFile)
	  ## write.table(outputMatrix, file=fjCsvOutputFile, row.names=FALSE, quote=FALSE, append=TRUE, sep=",")
	  write.csv(outputMatrix, file=fjCsvOutputFile, row.names=FALSE, quote=FALSE)
  } else {
	  ## FlowJo
	  colnames(outputMatrix) <- paste0(derParName, 1:fjDims)
	  write.csv(cbind(eventNumbers, outputMatrix), file=fjCsvOutputFile, row.names=FALSE, quote=FALSE)
  }
  if (debug_input_output)
	  file.copy(fjCsvOutputFile, paste(fjCsvOutputFile, "backup.csv", sep="."))

}

# R seems to be saving the .RData when exiting, so let's clean up to at least make that tiny (i.e., empty environment)
rm(list=ls())
